clc;
clear all;
close all;
%% importdata;
fAd1='P:\Experiment\Original experiment datas of projects\Project 1 High nonlinearity of DSTMS studied by Z-scan\Polarization dependent\OA\';
fAd2='P:\Experiment\Original experiment datas of projects\Project 1 High nonlinearity of DSTMS studied by Z-scan\Polarization dependent\CA\';
filename1='highpower-';
filename2='lowpower-';
filename3='degree.thz';
theta=(linspace(0,90,10))';
theta1=(linspace(0,90,2^8))';
fid=fopen(strcat(fAd1,filename1,num2str(theta(1)),filename3),'rt');
indata = textscan(fid, '%f%f%f', 'HeaderLines',87);
fclose(fid);
z=-1e3*indata{1};%unit(mm);
% OA data
OAhigh=zeros(length(z),length(theta));
OAlow=zeros(length(z),length(theta));
OA=zeros(length(z),length(theta));
OAhigh1=zeros(length(theta),1);
% CA data
CAhigh=zeros(length(z),length(theta));
CAlow=zeros(length(z),length(theta));
CA=zeros(length(z),length(theta));
%% importdata
for ii=1:length(theta)
    % read in OA data
    fid=fopen(strcat(fAd1,filename1,num2str(theta(ii)),filename3),'rt');
    indata=textscan(fid, '%f%f%f', 'HeaderLines',87);
    OAhigh(:,ii)=indata{2};
    OAhigh1(ii)=OAhigh(1,ii);
    OAhigh(:,ii)=OAhigh(:,ii)/OAhigh1(ii);
    fclose(fid);
    fid=fopen(strcat(fAd1,filename2,num2str(theta(ii)),filename3),'r');
    indata=textscan(fid, '%f%f%f', 'HeaderLines',87);
    OAlow(:,ii)=indata{2};
    OAlow(:,ii)=OAlow(:,ii)/OAlow(1,ii);
    fclose(fid);
    OA(:,ii)=OAhigh(:,ii)./OAlow(:,ii);
    OA(:,ii)=OA(:,ii)/(sum(OA(1:20,ii))/20);
    % read in CA data
    fid=fopen(strcat(fAd2,filename1,num2str(theta(ii)),filename3),'rt');
    indata=textscan(fid, '%f%f%f', 'HeaderLines',87);
    CAhigh(:,ii)=indata{2};
    CAhigh(:,ii)=CAhigh(:,ii)/CAhigh(1,ii);
    fclose(fid);
    fid=fopen(strcat(fAd2,filename2,num2str(theta(ii)),filename3),'rt');
    indata=textscan(fid, '%f%f%f', 'HeaderLines',87);
    CAlow(:,ii)=indata{2};
    CAlow(:,ii)=CAlow(:,ii)/CAlow(1,ii);
    fclose(fid);
    CA(:,ii)=CAhigh(:,ii)./CAlow(:,ii);
    CA(:,ii)=CA(:,ii)/(sum(CA(1:10,ii))/10);
end
z=z-z(OA(:,1)==min(OA(:,1)));
%% experiment parameters
lambda=1.43e-4; % center wavelength(cm)
na=nNIR(lambda/1e-2);
nb=nbNIR(lambda/1e-2);
ntheta=sqrt((na*cosd(theta)).^2+(nb*sind(theta)).^2);
Ttheta=1-(ntheta-1).^2./(ntheta+1).^2;
d=4e-2; % thickness of DSTMS(cm);
E=20e-9; % pulse energy(J);
FWHM=75e-15; % FWHM duration of OPA pulses(s);
alpha=1; % absorption coefficient(cm^-1)
Leff=(1-exp(-alpha*d))/alpha; % effective propagation length in DSTMS
k=2*pi/lambda; % wavenumber(cm^-1)
%% fitted by theoretical model
% Ref: IEEE Journal of Quantum Electronics, 26(4), 760?769(1990)
reT=zeros(length(z),length(theta));
for ii=1:length(theta)
    reT(:,ii)=CA(:,ii)./OA(:,ii);
    reT(:,ii)=reT(:,ii)/(sum(reT(1:20,ii))/20);
end
% Fitted by theoretical model
Ntheta=length(theta);
dPhi=zeros(Ntheta,1);
z0=zeros(4,1);
ciPhi=zeros(Ntheta,1);
ciZ0=zeros(4,1);
% fit to obtain value of z0
foZ0=fitoptions('Method','NonlinearLeastSquares',...
    'Lower',[0,0.5],...
    'Upper',[3,3],...
    'StartPoint',0);
ftZ0=fittype('1+dPhi*(x/z0)/((x/z0)^2+9)/((x/z0)^2+1)',...
    'coefficients',{'dPhi','z0'},...
    'option',foZ0);% fit function for Z0;
for ii=1:4
    n2_0deg=fit(z,reT(:,ii),ftZ0,...
        'StartPoint',[0,1]);
    fitparameters=coeffvalues(n2_0deg);
    dPhi(ii)=fitparameters(1);
    z0(ii)=fitparameters(2);
    ciFit=confint(n2_0deg);% 95% confident interval for fit parameters
    ciPhi(ii)=ciFit(2,1)-dPhi(ii);
    ciZ0(ii)=ciFit(2,2)-z0(ii);
end
z0Fit=sum(z0)/length(z0);
% fit n2 parameters
foN2=fitoptions('Method','NonlinearLeastSquares',...
    'Lower',-4,...
    'Upper',4,...
    'StartPoint',0);
ftN2=fittype('1+dPhi*(x/z0)/((x/z0)^2+9)/((x/z0)^2+1)',...
    'coefficients','dPhi',...
    'problem','z0',...
    'option',foN2);% fit function for N2;
for ii=5:Ntheta
    fN2=fit(z,reT(:,ii),ftN2,...
        'StartPoint',0,...
        'problem',z0Fit);
    dPhi(ii)=coeffvalues(fN2);
    ciFit=confint(fN2);
    ciPhi(ii)=ciFit(2)-dPhi(ii);
end
w0=sqrt(z0Fit*lambda/(2*pi*1e1));
fluence=E/(pi*w0^2); % pump fluence of OPA pulses(J/cm^2)
I0=fluence/(FWHM/1.665)/1e9*Ttheta(1:Ntheta); % peak power of OPA light(GW/cm^2)
n2=1e5*sqrt(2)*dPhi./(4*Leff*I0*k);
ciN2=1e5*sqrt(2)*ciPhi./(4*Leff*I0*k);
%% fitted by two-photon absorption model
%I0=fluence/(FWHM/1.665)/1e9*Ttheta;
N=3; % two photon absorption
A=I0.^(N-1)*d/N^(3/2);
A2=I0*d/2^(3/2);
fo=fitoptions('Method','NonlinearLeastSquares',...
               'Lower',-0.5,...
               'Upper',2,...
               'StartPoint',0);
beta2=zeros(Ntheta,1);
cibeta2=zeros(Ntheta,1);
ft=fittype('1/(1+A*beta2/(1+(x/Z0)^2)^(N-1))',...
    'problem',{'N','A','Z0'},...
    'coefficients','beta2',...
    'options',fo);% aN...coefficient of multiphoton absorption(cm/GW)
f2= fit(z,OA(:,1),ft,'problem',{2,A2(1),z0Fit});
f3=fit(z,OA(:,1),ft,'problem',{N,A(1),z0Fit});
% polarization depedent beta2
for ii=1:Ntheta
%     if ii<=10
       fbeta2= fit(z,OA(:,ii),ft,'problem',{N,A(ii),z0Fit});
       beta2(ii)=coeffvalues(fbeta2);
       ciFit=confint(fbeta2);
       cibeta2(ii)=ciFit(2)-beta2(ii);
       if beta2(ii)<=0
           beta2(ii)=0;
       end
%     else 
%         f=fit(z,OA(:,ii),ft,'problem',{3,A(ii),z0Fit});
%         beta2(ii)=coeffvalues(f);
%     end
end
%% fit polarization dependent n2 and beta3
wbeta2=1.96./cibeta2;
wN2=1.96./ciN2;

fun1=@(a,x)a*cosd(x).^4;
fun2=@(b,x)b*cosd(x).^6;

N2theta=fitnlm(theta(1:Ntheta),n2,fun1,n2(1),'weight',wN2);
beta2theta=fitnlm(theta(1:Ntheta),beta2,fun2,beta2(1),'weight',wbeta2);

%% plot figures
figure(1)
beta2_0deg=fit(z,OA(:,1),ft,'problem',{3,A(1),z0Fit});
beta2_90deg=fit(z,OA(:,10),ft,'problem',{3,A(10),z0Fit});

h1_1=plot(z,OA(:,1),'o','MarkerSize',9);
set(h1_1,'markerfacecolor', get(h1_1, 'color'));
hold on
h1_2=plot(z,OA(:,10),'o','MarkerSize',9);
set(h1_2,'markerfacecolor', get(h1_2, 'color'));

h0deg=plot(beta2_0deg);
h0deg.LineWidth=2;
h0deg.Color=get(h1_1, 'color');

h90deg=plot(beta2_90deg);
h90deg.LineWidth=2;
h90deg.Color=get(h1_2, 'color');

hold off
Ax1=gca;
axis([-15,15,0.6,1.4])
set(Ax1,'FontSize',16,...
    'xtick',[-15,-10,-5,0,5,10,15],...
    'ytick',[0.6,0.8,1.0,1.2,1.4])
xlabel('z(mm)','FontSize',18)
ylabel('Transmittance,T_{OA}(a.u.)','FontSize',18)
legend({'Experiment-0deg','Experiment-90deg','Fitting-0deg','Fitting-90deg'},...
    'FontSize',16,...
    'Location','northeast')

figure(2)
h2_1=plot(z,OA(:,1),'o','MarkerSize',8);
set(h2_1, 'markerfacecolor', get(h2_1, 'color')); 
hold on
h2_2=plot(f2);
h2_2.LineWidth=2;
h2_2.LineStyle='--';

h2_3=plot(f3);
h2_3.LineWidth=2;
h2_3.Color=get(h2_1, 'color');

Ax2=gca;
axis([-15,15,0.6,1.4])
set(Ax2,'FontSize',16,...
    'xtick',[-15,-10,-5,0,5,10,15],...
    'ytick',[0.6,0.8,1.0,1.2,1.4])
xlabel('z(mm)','FontSize',18)
ylabel('Transmittance,T_{OA}(a.u.)','FontSize',18)
legend({'Experiment','2PA model fitting','3PA model fitting'},...
    'Location','northeast',...
    'FontSize',16)

figure(3)
h3=errorbar(theta(1:Ntheta),beta2*1e2,cibeta2*1e2,'o',...
    'linewidth',1.5,...
    'MarkerSize',10);
set(h3, 'markerfacecolor', get(h3, 'color'));
hold on
line(theta1,predict(beta2theta,theta1)*1e2,...
    'linestyle','-',...
    'color','r',...
    'linewidth',2)
hold off
Ax3=gca;
axis([0,90,0,8])
xt=linspace(0,90,4);
yt=linspace(0,8,5);
set(Ax3,'FontSize',16,...
    'xtick',xt,...
    'ytick',yt)
xlabel('\theta(deg)','FontSize',18)
ylabel('\gamma(\times 10^{-2}cm^3/GW^2)','FontSize',18)
legend({'Experiment','cos^6\theta'},...
    'FontSize',16)

figure(4)
h6_1=errorbar(theta(1:Ntheta),n2,ciN2,'o',...
    'MarkerSize',10,...
    'linewidth',1.5);
set(h6_1, 'markerfacecolor', get(h6_1, 'color'));
hold on
line(theta1,predict(N2theta,theta1),...
    'linestyle','-',...
    'color','r',...
    'linewidth',2)
hold off
Ax5=gca;
axis([0,90,-0.5,3])
xt=linspace(0,90,4);
yt=linspace(-0,3,4);
set(Ax5,'FontSize',16,...
    'xtick',xt,...
    'ytick',yt)
xlabel('\theta(deg)','FontSize',18)
ylabel('n_2(\times 10^{-18} m^2/W)','FontSize',18)
legend({'Experiement','cos^4\theta'},...
    'FontSize',16)

figure(5)
n2_0deg= fit(z,reT(:,1),ftZ0,...
    'StartPoint',[0,1]);
n2_90deg= fit(z,reT(:,10)/(sum(reT(1:end,10))/length(z)),ftN2,...
    'StartPoint',0,...
    'problem',z0Fit);

h6_1=plot(z,reT(:,1),'o',...
    'MarkerSize',8);
set(h6_1, 'markerfacecolor', get(h6_1, 'color'));
hold on
h6_2=plot(z,reT(:,10)/(sum(reT(1:end,10))/length(z)),'o',...
    'MarkerSize',8);
set(h6_2, 'markerfacecolor', get(h6_2, 'color'));

h0deg=plot(n2_0deg);
h0deg.LineWidth=2;
h0deg.Color=get(h6_1, 'color');

h90deg=plot(n2_90deg);
h90deg.LineWidth=2;
h90deg.Color=get(h6_2, 'color');

hold off
Ax5=gca;
axis([-15,15,0.6,1.4])
set(Ax5,'FontSize',16,...
    'xtick',[-15,-10,-5,0,5,10,15],...
    'ytick',[0.6,0.8,1.0,1.2,1.4])
xlabel('z(mm)','FontSize',18)
ylabel('Transmittance,T_{CA}/T_{OA}(a.u.)','FontSize',18)
legend({'Experiment-0deg','Experiment-90deg','Fitting-0deg','Fitting-90deg'},...
    'FontSize',16)